%define real_name hid-shanwan

%global commit ec33e56d9346b0bf638987d2c379ed25b4248589
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global gitdate 20220530

Summary: This is a kernel module for the specific (2563:0575)Shanwan USB WirelessGamepad gamepad.
Name: dkms-hid-shanwan
Version: 1.0.0
Release: 1.git%{gitdate}%{?dist}
License: GPL-2.0-or-later
Group: System Environment/Kernel
URL: https://github.com/hbiyik/hid-shanwan
Source0: https://github.com/hbiyik/hid-shanwan/archive/%{commit}/hid-shanwan-%{shortcommit}.tar.gz
BuildArch: noarch
Requires: gcc
Requires: make
Requires: kernel-devel
Requires: kernel-modules
Requires(post): dkms
Requires(preun): dkms

%description
This is a kernel module for the specific (2563:0575)Shanwan USB WirelessGamepad gamepad

%prep
%setup -q -n %{real_name}-%{commit}

%build

%install
%{__rm} -rf %{buildroot}


%define dkms_name hid-shanwan
%define dkms_vers %{version}-%{release}
%define quiet -q

# Kernel module sources install for dkms
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cp} -a hid-shanwan.c Makefile %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Configuration for dkms
%{__cat} <<'EOF' >%{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="'make' -j$(nproc) KVER=${kernelver}"
CLEAN[0]="'make' clean"
BUILT_MODULE_NAME[0]=%{dkms_name}
DEST_MODULE_LOCATION[0]=/kernel/drivers/hid
AUTOINSTALL="YES"
EOF

%post
# Add to DKMS registry
dkms --rpm_safe_upgrade add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms --rpm_safe_upgrade build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms --rpm_safe_upgrade install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms --rpm_safe_upgrade remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :

%files
%defattr(-, root, root, -)
%doc readme.md
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

%changelog
* Fri Nov 10 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 1.0.0-1.git20220530
- The first release
